<id>
PointsMod for SP1.1 (version 1.1-2)
</id>

<version>
1.1 upgrade 2
</version>

<mod info>
This mod implements a point counter mechanism for board moderation.

Each user has a new field in their profile telling how many points they have left. These points are taken away by admin/moderators if the user does something bad. When the points become negative, the user can no longer post. However, the points counter recharges itself slowly in a certain time. When the counter reaches its maximum, it stops recharging.

Version: 1.1 (upgrade 2)

Supports: YaBB SP 1.1 only (This is a conversion from the mod for SP 1.3.1)

Features:
- can place a comment on why points were taken or given
- Moderator notes/comments are protected from user editing
- Moderator comments can be hidden from the public:
    - Everyone sees notes & points
    - Everyone sees points
    - Only poster, moderators, admin
- can both increment and decrement the counter
- counter can be displayed in the profile:
    - as plaintext
    - as a % gauge
    - as a custom gauge (see included file "Customizing PointsMod.txt")
- profile displays a "list of offenses", which contains:
    - Post date, subject and modification done by moderator
- can set recharge time (in days)
- can set recharge time separately for positive and negative counter values
- can toggle between "admin only"/"admin and moderators"
- can set default and max. amounts for counter
- can set maximum Poster's licence points change for one modification, modes:
    - No limit (text-field)
    - Constrain (drop-down select)
    - Validate (text-field with warning)
- can turn mod on/off from Admin settings
- all known bugs fixed

Installation:
Apply the mod.

Upload the modified files (in ASCII mode):
english.lng
Sources/Profile.pl
Sources/Load.pl
Sources/Post.pl
Sources/ModifyMessage.pl
Sources/Display.pl
Sources/Settings.pl
Sources/AdminEdit.pl
Sources/YaBBC.pl
Sources/Subs.pl

Upload (in ASCII mode):
PointsMod.pl
cards.pm_gauge
to your Sources folder.

Upload (in Binary mode):
The .gif images to your Images folder.

Total development time for mod (days): 3 days.
</mod info>

<author>
mixu
</author>

<homepage>
http://mixu.net/
</homepage>

<edit file>
Sources\Profile.pl
</edit file>

<search for>
	$online =~ s~\?~<i>$txt{'687'}</i>.~;
	if($memsettings[6] > 100000) { $memsettings[6] = "$txt{'683'}"; }
</search for>

<add after>
    &pm_LoadUserPoints($INFO{'username'});
    my $pm_t1 = int(($userpdt[0]/$pm_max_value)*100);
    if ($pm_profilestyle == 1) {
        my $pm_t2 = int($pm_t1*1.5); # true max width is 150 px + 5 + 5
        if ($pm_t2 > 150) {$pm_t2 = 150;}
        $pointsmod_memberp = qq~<img src="$imagesdir/pm_bar1_1.gif" alt=""><img src="$imagesdir/pm_bar1_2.gif" height="11" width="$pm_t2" alt=""><img src="$imagesdir/pm_bar1_3.gif" alt=""> @userpdt[0]/$pm_max_value <i>($pm_t1 %)</i>~;
    } elsif (($pm_profilestyle == 2) && defined($pm_custom_filename) && $pm_custom_filename ne '') {
        &pm_LoadCustomProfileDisplay($pm_custom_filename);
        if ($pm_custom_images_type eq '%') {
            my $tens = (int($pm_t1/10))*10;
            my $i;
            if ($tens < 0) {$tens -= 10; $i = 100;} else {$tens +=10; $i = 0;}
                while(1){
                if (($tens < 0) && ($i < $tens)) {last;}
                if (($tens > 0) && ($i > $tens)) {last;}
                if (($pm_custom_images{"<$i%"} ne '')){
                    $pointsmod_memberp = $pm_custom_images{"<$i%"};
                }

                if ($tens < 0) {$i = $i - 10;} else {$i = $i + 10;}
            }
        } elsif ($pm_custom_images_type eq 'e') {
            my $i = $userpdt[0];
            if ($i < 0) {$pointsmod_memberp = $pm_custom_images{('<0e')} }
            while ($i > -1) {
                if (($pm_custom_images{('='.$i.'e')} ne '')){
                    $pointsmod_memberp = $pm_custom_images{('='.$i.'e')};
                    last;
                }
                $i--;
            }
        }
    } else {
        # 0 - defaults to plaintext
        $pointsmod_memberp = "@userpdt[0]/$pm_max_value";
    }

    if ($pm_custom_implements_link_to_offenseslist == 0){
        $pointsmod_memberp .= qq~<br><font size="-2">[<a href="$scripturl?action=pm_offenses;username=$INFO{'username'}">$pointsmod{'25'}</a>]</font>~;
    }
</add after>

<search for>
      </tr><tr>
        <td><font size=2><b>$txt{'86'}: </b></font></td>
        <td><font size=2>$memsettings[6]</font></td>
      </tr><tr>
</search for>

<add after>
      ~;
    if ($pm_on_off == 1) {
        $yymain .= qq~
            <td><font size=2><b>$pointsmod{'1'}: </b></font></td>
            <td><font size=2>$pointsmod_memberp</font></td>~;
    }
    $yymain .= qq~</tr><tr>
</add after>

<search for>
		if($settings[7] eq 'Administrator') {
			unlink("$memberdir/$member{'username'}.dat");
			unlink("$memberdir/$member{'username'}.msg");
			unlink("$memberdir/$member{'username'}.log");
	                unlink("$memberdir/$member{'username'}.outbox");
	                unlink("$memberdir/$member{'username'}.imconfig");
</search for>

<add after>
			unlink("$memberdir/$member{'username'}.pdt");
</add after>

<search for>
		elsif( $member{'username'} eq $username ) {
			unlink("$memberdir/$username.dat");
			unlink("$memberdir/$username.msg");
			unlink("$memberdir/$username.log");
	                unlink("$memberdir/$username.outbox");
	                unlink("$memberdir/$username.imconfig");
</search for>

<add after>
			unlink("$memberdir/$member{'username'}.pdt");
</add after>

<edit file>
Sources\Load.pl
</edit file>

<search for>
sub LoadIMs {
</search for>

<add before>
sub pm_LoadUserPoints {
	my $user = shift;
	my $ydaytimediff;
    @userpdt = undef;
    if(fopen(PDATA, "$memberdir/$user.pdt")){
        @userpdt = <PDATA>;
        fclose(PDATA);
        chomp @userpdt;
        $ydaytimediff = ((gmtime(time-$userpdt[1]))[7]);
        if ((($userpdt[0] < -1)
            && ($ydaytimediff >= $pm_days_negative_increment))
          || (($userpdt[0] > -1)
            && ($ydaytimediff >= $pm_days_positive_increment)))
          {
            if ($userpdt[0] < $pm_max_value){
                if ($ydaytimediff >= $pm_days_positive_increment) {$ydaytimediff = int($ydaytimediff/$pm_days_positive_increment);}
                if ($ydaytimediff >= $pm_days_negative_increment) {$ydaytimediff = int($ydaytimediff/$pm_days_negative_increment);}
                $userpdt[0] = $userpdt[0]+$ydaytimediff;
                $userpdt[1] = time;
                &pm_SaveUserPoints($user);
            }
        }
    } else {
        @userpdt = ($pm_default_value, '-1');
    }
}

sub pm_LoadCustomProfileDisplay{
    my $displayname = shift;
    require "$displayname";
}

sub pm_SaveUserPoints{
	my $user = shift;
    if(fopen(PDATA, ">$memberdir/$user.pdt", 1)){
        foreach (@userpdt){
		print PDATA $_."\n";
		}
    fclose(PDATA);
    }
}

</add before>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>
# PointsMod 1.1 upgrade 2
$pointsmod{'0'} = 'PointsMod 1.1 for YaBB SP 1.1 (upgrade 2)';
$pointsmod{'1'} = "Poster's licence points";
$pointsmod{'2'} = "poster's licence points";
$pointsmod{'3'} = "You can't post right now <b>because you have negative $pointsmod{'2'}</b>.<br>You will need to wait a few days until you are at 0 $pointsmod{'2'}.";
$pointsmod{'4'} = "You can't modify posts right now <b>because you have negative $pointsmod{'2'}</b>.<br>You will need to wait a few days until you are at 0 $pointsmod{'2'}.";
$pointsmod{'5'} = "Edit points";
$pointsmod{'6'} = qq~<img src="$imagesdir/pm_edit.gif" alt=""> Modify $pointsmod{'2'}~;
$pointsmod{'7'} = "Modify $pointsmod{'2'} for user";
$pointsmod{'8'} = 'Amount';
$pointsmod{'9'} = "(When the user's $pointsmod{'2'} goes under 0, he/she cannot post.)";
$pointsmod{'10'} = 'Add an explanation to the post?';
$pointsmod{'11'} = '(Adds an explanatory remark to the end of this post.)';
$pointsmod{'12'} = 'Explanation for modification:';
$pointsmod{'13'} = 'Submit';
$pointsmod{'14'} = 'This post was smited';
$pointsmod{'15'} = 'This post was applauded';
$pointsmod{'16'} = 'points';
$pointsmod{'17'} = 'by';
$pointsmod{'18'} = 'Allow moderators to use PointsMod??';
$pointsmod{'19'} = 'How many days to gain one point while point count is negative?';
$pointsmod{'20'} = 'How many days to gain one point while point count is positive?';
$pointsmod{'21'} = 'Users start with ';
$pointsmod{'22'} = 'Maximum amount of points is ';
$pointsmod{'23'} = 'Maximum change allowed:';
$pointsmod{'24'} = "<b>Maximum change allowed is $pm_max_change!!</b> You can't set an amount higher than that.";
$pointsmod{'25'} = 'List of offenses';
$pointsmod{'26'} = 'for';
$pointsmod{'27'} = 'Points';
$pointsmod{'28'} = 'Select profile page display type';
$pointsmod{'29'} = 'Plaintext';
$pointsmod{'30'} = 'Gauge';
$pointsmod{'31'} = 'Custom';
$pointsmod{'32'} = 'Select "Custom"-mode gauge file';
$pointsmod{'33'} = 'Mode for Maximum points change enforcement';
$pointsmod{'34'} = 'No limit (text-field)';
$pointsmod{'35'} = 'Constrain (drop-down select)';
$pointsmod{'36'} = 'Validate (text-field with warning)';
$pointsmod{'37'} = 'Maximum points change limit (for each modification)';
$pointsmod{'38'} = 'Mode for showing moderator notes';
$pointsmod{'39'} = 'Everyone sees notes & points';
$pointsmod{'40'} = 'Everyone sees points';
$pointsmod{'41'} = 'Only poster, moderators, admin';
$pointsmod{'42'} = 'This dialog shows all posts by ';
$pointsmod{'43'} = ' which have been commented by moderators.';
$pointsmod{'44'} = 'No commented posts found for this user.';
$pointsmod{'45'} = "Enable $pointsmod{'0'}?";
$pointsmod{'46'} = ' <i>(Checked = on, unchecked = off)</i>';
$pointsmod{'47'} = " <i>(Moderator's can't use PointsMod if it's not enabled)</i>";
$pointsmod{'48'} = 'Warning';
$pointsmod{'49'} = " $pointsmod{'1'} low!";
$pointsmod{'50'} = "Your $pointsmod{'1'} are running low. If they become negative, you can no longer post to this forum - please try to follow the posting policy enforced by our board's moderators. NOTE: This warning is sent to you automatically.";
$pointsmod{'51'} = 'Automatic "points-low" warning method:';
$pointsmod{'52'} = "$pointsmod{'1'} count for auto warning at:";
$pointsmod{'52a'} = 'Automatic warning';
$pointsmod{'52b'} = 'popup';
$pointsmod{'52c'} = 'IM';
$pointsmod{'53'} = "$pointsmod{'52a'} $pointsmod{'52c'} subject:";
$pointsmod{'54'} = "$pointsmod{'52a'} $pointsmod{'52c'} message:";
$pointsmod{'55'} = "$pointsmod{'52a'} $pointsmod{'52b'} title:";
$pointsmod{'56'} = "$pointsmod{'52a'} $pointsmod{'52b'} body:";
$pointsmod{'57'} = 'settings';
$pointsmod{'58'} = 'Profile page gauge';
$pointsmod{'59'} = qq~ <table bgcolor="$windowbg2" class="windowbg2"><tr><td><b>Your $pointsmod{'1'} are running low.</b></td><td>If they become negative, you can no longer post to this forum - please try to follow the posting policy enforced by our board's moderators. NOTE: This warning is sent to you automatically.</td></tr></table>~;
$pointsmod{'60'} = 'You have ';
# end PointsMod 1.1 upgrade 2
</add after>

<search for>
if($MenuType == 1) {
	$menusep = ' <font size="1">&#005;</font>';
	$img{'admin'} = qq~<font size="1" class="imgmenu">$txt{'2'}</font>~;
</search for>

<add after>
$img{'pm_edit'} = qq~<font size="1" class="imgcatbg">$pointsmod{'5'}</font>~;
</add after>

<search for>
else {
	$menusep = ' ';
	$img{'admin'} = qq~<img src="$imagesdir/admin.gif" alt="$txt{'2'}" border="0"> <font size="1" class="imgmenu">$txt{'2'}</font>~;
</search for>

<add after>
$img{'pm_edit'} = qq~<font size="1" class="imgcatbg"><img src="$imagesdir/pm_edit.gif" alt="$pointsmod{'5'}" border="0">$pointsmod{'5'}</font>~;
</add after>

<edit file>
Sources\Post.pl
</edit file>

<search for>
sub Post {
	if($username eq 'Guest' && $enable_guestposting == 0) { &fatal_error($txt{'165'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'3'}); }
</add after>

<search for>
sub Post2 {
	if($username eq 'Guest' && $enable_guestposting == 0) {	&fatal_error($txt{'165'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'3'}); }
</add after>

<search for>
		if($quotemsg ne '') {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns) = split(/\|/,$messages[$quotemsg]);
</search for>

<add after>
            @pm_points = undef;
            @pm_notes = undef;
            $mmessage = pm_DeUBBCProcess($mmessage);
</add after>

<search for>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr>
~;
}
else {
	$yymain .= qq~
      <tr>
        <td bgcolor="$color{'bordercolor'}" colspan="2">
        <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
~;
}
</search for>

<add after>
my $iterator;
for($iterator = 0; $iterator <= scalar(@pm_points); $iterator++){
    if ($pm_points[$iterator] ne '') {
    $yymain .= qq~<input type="hidden" name="pm_points$iterator" value="$pm_points[$iterator]">~;
    }
}
for($iterator = 0; $iterator <= scalar(@pm_notes); $iterator++){
    if ($pm_notes[$iterator] ne '') {
    $yymain .= qq~<input type="hidden" name="pm_notes$iterator" value="$pm_notes[$iterator]">~;
    }
}
</add after>

<search for>
sub Preview {
	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$sub = $FORM{'subject'};
	$mess = $FORM{'message'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	$notify = $FORM{'notify'};
	$postid = $FORM{'postid'};
	if (length($subject) > 50) { $sub = substr($subject,0,50); }
	&ToHTML($sub);
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1$2~g;
	&ToHTML($message);
	$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$message =~ s/\n/<br>/g;
	&CheckIcon;
</search for>

<add after>
    if($FORM{'waction'} eq 'previewmodify'){
       my $iterator = 1;
        while(defined($FORM{"pm_points$iterator"})){
            $message .= '[pm_moderation_note='.$FORM{"pm_points$iterator"}.'pm_end]'.$FORM{"pm_notes$iterator"}.'[/pm_moderation_note]';
            $iterator++;
        }
        @pm_points = undef;
        @pm_notes = undef;
# Uncomment if you would like to see Moderator notes on the preview...
#        my $load_message = $message;
#        $load_message = pm_DeUBBCProcess($message);
        $message = pm_DeUBBCProcess($message);
    }
</add after>

<edit file>
Sources\ModifyMessage.pl
</edit file>

<search for>
sub ModifyMessage {
	if($username eq 'Guest') { &fatal_error($txt{'223'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'4'}); }
</add after>

<search for>
sub ModifyMessage2 {
	if($username eq 'Guest') { &fatal_error($txt{'223'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'4'}); }
</add after>

<search for>
	if($musername ne $username && (!exists $moderators{$username}) && $settings[7] ne 'Administrator' ) {
		&fatal_error($txt{'67'});
	}

	$lastmod = $mlm ? &timeformat($mlm) : '-';
	$nscheck = $mns ? ' checked' : '';
</search for>

<add before>
    @pm_points = undef;
    @pm_notes = undef;
    $message = pm_DeUBBCProcess($message);
</add before>

<search for>
		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		&ToHTML($subject);
		&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~ );
		$message =~ s/\cM//g;
		$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
		$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
		$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
		&ToHTML($message);
		$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
		$message =~ s/\n/<br>/g;
</search for>

<add after>
    my $iterator = 1;
    while(defined($FORM{"pm_points$iterator"})){
        $message .= '[pm_moderation_note='.$FORM{"pm_points$iterator"}.'pm_end]'.$FORM{"pm_notes$iterator"}.'[/pm_moderation_note]';
        $iterator++;
    }
</add after>

<edit file>
Sources\Display.pl
</edit file>

<search for>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername) {
		$yymain .= qq~  $menusep<a href="javascript:DoConfirm('$txt{'739'}','$cgi;action=modify2;thread=$viewnum;id=$counter;d=1')">$img{'delete'}</a>~;
	}
</search for>

<add after>
    if(($settings[7] eq 'Administrator') || (($pm_allow_moderators == 1) && (exists $moderators{$username}))) {
        if (($musername ne 'Guest') && ($pm_on_off == 1)) {
            $yymain .= qq~  $menusep<a href="$cgi;action=pm_edit;message=$counter;thread=$viewnum;musername=$userprofile[1]">$img{'pm_edit'}</a>~;
        }
    }
</add after>

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'profile') { require "$sourcedir/Profile.pl"; &ModifyProfile; }
	elsif ($action eq 'profile2') { require "$sourcedir/Profile.pl"; &ModifyProfile2; }
</search for>

<add after>
	elsif ($action eq 'pm_edit') { require "$sourcedir/PointsMod.pl"; &pm_Edit; }
	elsif ($action eq 'pm_edit2') { require "$sourcedir/PointsMod.pl"; &pm_Edit2; }
	elsif ($action eq 'pm_offenses') { require "$sourcedir/PointsMod.pl"; &pm_OffensesList; }
	elsif ($action eq 'pm_note_popup') { require "$sourcedir/PointsMod.pl"; &pm_NotePopup; }
</add after>

<edit file>
Settings.pl
</edit file>

<search for>
########## Membergroups ##########
</search for>

<add before>
########### PointsMod 1.1 upgrade 2 #########

$pm_allow_moderators = 1;                                             # Allow moderators to use PointsMod?? 0 - no, 1 - yes
$pm_days_negative_increment = 2;                                      # How many days to gain one point while PointCount is negative?
$pm_days_positive_increment = 4;                                      # How many days to gain one point while PointCount is positive?
$pm_default_value = 10;                                               # The default PointCount for users
$pm_max_value = 25;                                                   # The maximum PointCount
$pm_profilestyle = 1;                                                 # Profile style: 0 - plaintext, 1 - gauge, 2 - custom
$pm_custom_filename = "$sourcedir/cards.pm_gauge";                    # Custom profile style
$pm_use_max_change = 1;                                               # Mode for Maximum change enforcement: 0 - off, 1 - constrain (drop-down style), 2 - validate (textbox with message)
$pm_max_change = 10;                                                  # Maximum change possible in points
$pm_restrict_moderator_notes = 0;                                     # Mode for showing moderator notes: 0 - everyone sees notes & points, 1 - everyone sees points, 2 - only poster, moderators, admin
$pm_on_off = 1;                                                       # 1 - mod enabled, 0 - mod disabled

# The $pointsmod texts here will be removed when you edit you Admin settings!!
$pointsmod{'1'} = "Poster's licence points";
$pointsmod{'48'} = 'Warning';
$pointsmod{'49'} = " $pointsmod{'1'} low!";
$pointsmod{'50'} = " Your $pointsmod{'1'} are running low. If they become negative, you can no longer post to this forum - please try to follow the posting policy enforced by our board's moderators. NOTE: This warning is sent to you automatically.";

$pm_notify_when = 3;                                                  # at what point will the user be warned "points are low"
$pm_notify_mode = 0;                                                  # Mode for auto warning: 0 - none, 1 - IM, 2 - popup
$pm_notify_im_subject = "$pointsmod{'48'}:$pointsmod{'49'}";            # Subject in warning IM
$pm_notify_im_message = $pointsmod{'50'};                             # Message in warning IM
$pm_notify_popup_subject = "$pointsmod{'48'}:$pointsmod{'49'}";         # Title in warning popup
$pm_notify_popup_message = qq~<body bgcolor="$color{'catbg'}"><table cellspacing=0 cellpadding=0 width="95%" bgcolor="$color{'windowbg'}"><tr><td bgcolor="$color{'titlebg'}"><b><font color="#FFFFFF">Your $pointsmod{'1'} are running low.</font></b></td></tr><tr><td>If they become negative, you can no longer post to this forum - please try to follow the posting policy enforced by our board's moderators.<br><i>NOTE: This warning is sent to you automatically.</i></td></tr></table></body>~;# Body in warning popup

</add before>

<edit file>
Sources\AdminEdit.pl
</edit file>

<search for>
sub ModifySettings {
	&is_admin;
</search for>

<add after>
    my($pm_am1, $pm_am2, $pm_ps1, $pm_ps2, $pm_ps3, $pm_cf_options, $pm_umc1, $pm_umc2, $pm_umc3, $pm_rmn1, $pm_rmn2, $pm_rmn3);
    my($pm_on_offchecked, $pm_nm1, $pm_nm2, $pm_nm3);
</add after>

<search for>
	# figure out what to print
</search for>

<add after>
    if ($pm_allow_moderators == 1){$pm_am1 = ' selected';} else {$pm_am2 = ' selected';}
    if ($pm_profilestyle == 0){$pm_ps1 = ' selected';}
    elsif ($pm_profilestyle == 1){$pm_ps2 = ' selected';}
    elsif ($pm_profilestyle == 2){$pm_ps3 = ' selected';}
    if ($pm_use_max_change == 0){$pm_umc1 = ' selected';}
    elsif ($pm_use_max_change == 1){$pm_umc2 = ' selected';}
    elsif ($pm_use_max_change == 2){$pm_umc3 = ' selected';}
    if ($pm_restrict_moderator_notes == 0){$pm_rmn1 = ' selected';}
    elsif ($pm_restrict_moderator_notes == 1){$pm_rmn2 = ' selected';}
    elsif ($pm_restrict_moderator_notes == 2){$pm_rmn3 = ' selected';}
    $pm_cf_options = '';
    foreach(<$sourcedir/*.pm_gauge>) {
            if ($_ eq $pm_custom_filename) {$pm_cf_options .= "<option selected>$_</option>";}
            else{
                $pm_cf_options .= "<option>$_</option>";
            }
    }
    if ($pm_on_off == 1) { $pm_on_offchecked = ' checked'; }
    if ($pm_notify_mode == 0){$pm_nm1 = ' selected';}
    elsif ($pm_notify_mode == 1){$pm_nm2 = ' selected';}
    elsif ($pm_notify_mode == 2){$pm_nm3 = ' selected';}
</add after>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'386'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showgenderimage" $sgichecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'740'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showyabbcbutt" $syabbcchecked></td>
</search for>

<add after>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <hr size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$pointsmod{'0'}</b></font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'45'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input class="windowbg2" type="checkbox" name="pm_on_off" value="1" $pm_on_offchecked>$pointsmod{'46'}</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'18'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="pm_allow_moderators"><option value="1"$pm_am1>$txt{'163'}</option><option value="0"$pm_am2>$txt{'164'}</option></select>$pointsmod{'47'}</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'38'}:</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="pm_restrict_moderator_notes"><option value="0"$pm_rmn1>$pointsmod{'39'}</option><option value="1"$pm_rmn2>$pointsmod{'40'}</option><option value="2"$pm_rmn3>$pointsmod{'41'}</option></select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" colspan=2><font size="2"><b>:: <i>$pointsmod{'1'} $pointsmod{'57'}</i> ::</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'21'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_default" value="$pm_default_value" size="3"> $pointsmod{'16'}.</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'22'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_max" value="$pm_max_value" size="3"> $pointsmod{'16'}.</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'37'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_max_change" value="$pm_max_change" size="3">  $pointsmod{'16'}.</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'33'}:</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="pm_use_max_change"><option value="0"$pm_umc1>$pointsmod{'34'}</option><option value="1"$pm_umc2>$pointsmod{'35'}</option><option value="2"$pm_umc3>$pointsmod{'36'}</option></select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'19'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_neg" value="$pm_days_negative_increment" size="3"> $txt{'579'}.</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'20'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_pos" value="$pm_days_positive_increment" size="3"> $txt{'579'}.</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" colspan=2><font size="2"><b>:: <i>$pointsmod{'58'} $pointsmod{'57'}</i> ::</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'28'}:</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="pm_profilestyle"><option value="0"$pm_ps1>$pointsmod{'29'}</option><option value="1"$pm_ps2>$pointsmod{'30'}</option><option value="2"$pm_ps3>$pointsmod{'31'}</option></select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'32'}:</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="pm_custom_filename">$pm_cf_options</select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" colspan=2><font size="2"><b>:: <i>$pointsmod{'52a'} $pointsmod{'57'}</i> ::</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'51'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="pm_notify_mode"><option value="0"$pm_nm1>None (off)</option><option value="1"$pm_nm2>Instant Message</option><option value="2"$pm_nm3>Popup window</option></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'52'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_notify_when" value="$pm_notify_when" size="3"> $pointsmod{'16'}.</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" colspan=2><font size="2"><b>:: <i>$pointsmod{'52a'} $pointsmod{'52c'} $pointsmod{'57'}</i> ::</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'53'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_notify_im_subject" value="$pm_notify_im_subject" size="45"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top"><font size="2">$pointsmod{'54'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><textarea name="pm_notify_im_message" rows="5" cols="60">$pm_notify_im_message</textarea></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" colspan=2><font size="2"><b>:: <i>$pointsmod{'52a'} $pointsmod{'52b'} $pointsmod{'57'}</i> ::</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pointsmod{'55'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="pm_notify_popup_subject" value="$pm_notify_popup_subject" size="45"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top"><font size="2">$pointsmod{'56'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><textarea name="pm_notify_popup_message" rows="6" cols="60">$pm_notify_popup_message</textarea></td>
  </tr><tr>
</add after>

<search for>
	$timeout = $FORM{'timeout'} || 5;
	$fadertime = $FORM{'fadertime'} || 5000;
	$timeselected = $FORM{'timeselect'} || 0;
	$timeoffset = $FORM{'timeoffset'} || 0;
	$TopAmmount = $FORM{'TopAmmount'} || 25;
	$MembersPerPage = $FORM{'MembersPerPage'} || 20;
	$maxdisplay = $FORM{'maxdisplay'} || 20;
	$maxmessagedisplay = $FORM{'maxmessagedisplay'} || 20;
	$max_log_days_old = $FORM{'max_log_days_old'} || 21;
</search for>

<add before>
    $pm_allow_moderators = $FORM{'pm_allow_moderators'} || 0;
    $pm_days_negative_increment = $FORM{'pm_neg'} || 2;
    $pm_days_positive_increment = $FORM{'pm_pos'} || 4;
    $pm_default_value = $FORM{'pm_default'} || 10;
    $pm_max_value = $FORM{'pm_max'} || 25;
    $pm_profilestyle = $FORM{'pm_profilestyle'} || 1;
    $pm_custom_filename = $FORM{'pm_custom_filename'} || "$sourcedir/cards.pm_gauge";
    $pm_use_max_change = $FORM{'pm_use_max_change'} || 1;
    $pm_max_change = $FORM{'pm_max_change'} || 10;
    $pm_restrict_moderator_notes = $FORM{'pm_restrict_moderator_notes'} || 0;
    $pm_on_off = $FORM{'pm_on_off'} || 0;
    $pm_notify_mode = $FORM{'pm_notify_mode'} || 0;
    $pm_notify_when = $FORM{'pm_notify_when'} || 3;
    $pm_notify_im_subject = $FORM{'pm_notify_im_subject'} || $pointsmod{'48'}.$pointsmod{'49'};
    $pm_notify_im_message = $FORM{'pm_notify_im_message'} || $pointsmod{'50'};
    $pm_notify_popup_subject = $FORM{'pm_notify_popup_subject'} || $pointsmod{'48'}.$pointsmod{'49'};
    $pm_notify_popup_message = $FORM{'pm_notify_popup_message'} || $pm_notify_popup_message;
</add before>

<search for>
########## Membergroups ##########
</search for>

<add before>
########### PointsMod 1.1 upgrade 2 #########

\$pm_allow_moderators = $pm_allow_moderators;  # Allow moderators to use PointsMod?? 0 - no, 1 - yes
\$pm_days_negative_increment = $pm_days_negative_increment; # How many days to gain one point while PointCount is negative?
\$pm_days_positive_increment = $pm_days_positive_increment; # How many days to gain one point while PointCount is positive?
\$pm_default_value = $pm_default_value; # The default PointCount for users
\$pm_max_value = $pm_max_value; # The maximum PointCount
\$pm_profilestyle = $pm_profilestyle;                                                 # Profile style: 0 - plaintext, 1 - gauge, 2 - custom
\$pm_custom_filename = "$pm_custom_filename";                                        # Custom profile style
\$pm_use_max_change = $pm_use_max_change;                                               # Mode for Maximum change enforcement: 0 - off, 1 - constrain (drop-down style), 2 - validate (textbox with message)
\$pm_max_change = $pm_max_change;                                                  # Maximum change possible in points
\$pm_restrict_moderator_notes = $pm_restrict_moderator_notes;                                     # Mode for showing moderator notes: 0 - everyone sees notes & points, 1 - everyone sees points, 2 - only poster, moderators, admin
\$pm_on_off = $pm_on_off;                                                       # 1 - mod enabled, 0 - mod disabled
\$pm_notify_when = $pm_notify_when;                                                  # at what point will the user be warned "points are low"
\$pm_notify_mode = $pm_notify_mode;                                                  # Mode for auto warning: 0 - none, 1 - IM, 2 - popup
\$pm_notify_im_subject = qq~$pm_notify_im_subject~;                     # Subject in warning IM
\$pm_notify_im_message = qq~$pm_notify_im_message~;                     # Message in warning IM
\$pm_notify_popup_subject = qq~$pm_notify_popup_subject~;               # Title in warning popup
\$pm_notify_popup_message = qq~$pm_notify_popup_message~;               # Body in warning popup

</add before>

<edit file>
Sources\Admin.pl
</edit file>

<search for>
	unlink("$memberdir/$currentmem.dat");
	unlink("$memberdir/$currentmem.msg");
	unlink("$memberdir/$currentmem.log");
	unlink("$memberdir/$currentmem.outbox");
	unlink("$memberdir/$currentmem.imconfig");
</search for>

<add after>
	unlink("$memberdir/$currentmem.pdt");
</add after>

<edit file>
Sources\Subs.pl
</edit file>

<search for>
sub exit {
	local $| = 1;
	local $\ = '';
	print '';
	CORE::exit( $_[0] || 0 );
}
</search for>

<add after>
sub pm_DeUBBCProcess {
    my $line = shift;
    while($line =~ s~\[pm_moderation_note=(.+?)pm_end\](.+?)\[/pm_moderation_note\]~~i){
        push @pm_points, $1;
        push @pm_notes, $2;
    }
    return $line;
}

</add after>

<search for>
sub template {
	if($yySetCookies1 || $yySetCookies2) { print header(-cookie=>[$yySetCookies1, $yySetCookies2], -charset=>'$yycharset'); }
	else { print header(-status=>'200 OK', -charset=>'$yycharset'); }

	$yyposition = $yytitle; $yytitle = "$mbname - $yytitle";

	$yymenu = qq~<a href="$scripturl">$img{'home'}</a>$menusep<a href="$helpfile" target="_blank" style="cursor:help;">$img{'help'}</a>$menusep<a href="$cgi;action=search">$img{'search'}</a>$menusep<a href="$scripturl?action=mlall">$img{'memberlist'}</a>~;
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
	if($username eq 'Guest') { $yymenu .= qq~$menusep<a href="$cgi;action=login">$img{'login'}</a>$menusep<a href="$cgi;action=register">$img{'register'}</a>~;
	} else {
		$yymenu .= qq~$menusep<a href="$cgi;action=profile;username=$useraccount{$username}">$img{'profile'}</a>~;
		if($enable_notification) { $yymenu .= qq~$menusep<a href="$cgi;action=shownotify">$img{'notification'}</a>~; }
		$yymenu .= qq~$menusep<a href="$cgi;action=logout">$img{'logout'}</a>~;
	}

	$yyimages = $imagesdir;
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] <= $pm_notify_when) && $pm_notify_mode == 2){
        if (fopen(FILE,"$datadir/pm_notify.txt")) {
            @pm_notify = <FILE>;
            fclose(FILE);
        }
        my $i;
    	for ($i = 0; $i <= scalar(@pm_notify)+1; $i++) {
    	   	if ($pm_notify[$i] eq $username) {
               	$yymenu .= qq~
<script language="JavaScript" type="text/javascript">
<!--
window.open("$cgi;action=pm_note_popup", "pm_note_popup", "width=300,height=180,location=0,menubar=0,directories=0,toolbar=0,status=0");
// -->
</script>
~;
            last;
            }
	    }
	    if ($i <= scalar(@pm_notify)) {
        		if (fopen(FILE, ">$datadir/pm_notify.txt", 1)) {
                    my $j;
                	for ($j = 0; $j <= scalar(@pm_notify); $j++){
                		if($j != $i) {print FILE $pm_notify[$j];}
                	}
                	fclose(FILE);
              }
        }
	}
</add after>

<edit file>
Sources\YaBBC.pl
</edit file>

<search for>
	if( $message =~ m~\[table\]\s*(.+?)\s*\[tr\]~i ) {
		while( $message =~ s~<marquee>(.*?)\[table\](.*?)\[/table\](.*?)</marquee>~<marquee>$1<table>$2</table>$3</marquee>~s ) {}
		while( $message =~ s~<marquee>(.*?)\[table\](.*?)</marquee>(.*?)\[/table\]~<marquee>$1\[//table\]$2</marquee>$3\[//table\]~s ) {}
		while( $message =~ s~\[table\](.*?)<marquee>(.*?)\[/table\](.*?)</marquee>~\[//table\]$1<marquee>$2\[//table\]$3</marquee>~s ) {}
		$message =~ s~\n{0,1}\[table\]\n*(.+?)\n*\[/table\]\n{0,1}~<table>$1</table>~isg;
		while( $message =~ s~\<table\>(.*?)\n*\[tr\]\n*(.*?)\n*\[/tr\]\n*(.*?)\</table\>~<table>$1<tr>$2</tr>$3</table>~is ) {}
		while( $message =~ s~\<tr\>(.*?)\n*\[td\]\n{0,1}(.*?)\n{0,1}\[/td\]\n*(.*?)\</tr\>~<tr>$1<td>$2</td>$3</tr>~is ) {}
	}
</search for>

<add after>
    if ($pm_on_off == 0) {
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~~isg;
    } elsif (
     # $pm_restrict_moderator_notes == everyone sees all
     ($pm_restrict_moderator_notes == 0)
     # or user is moderator, or admin
     ||($settings[7] eq 'Administrator' || (exists $moderators{$username}))
     # or this user is the poster
     ||($username eq $musername)
    ){
        # show notes and points
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~<p>$1: $2</p>~isg;
    } elsif (
     # $pm_restrict_moderator_notes == everyone sees points
     ($pm_restrict_moderator_notes == 1)
    ){
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~<p>$1.</p>~isg;
    } else {
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~~isg;
    }
</add after>

<edit file>
Sources\InstantMessage.pl
</edit file>

<search for>
#if there were invalid usernames in the recipient list, these names are listed after all valid users have been IMed
if (@nouser) {
	$badusers = join(" $txt{'763'} ", @nouser);
	$badusers =~ s/; $txt{'763'}/;/;
	&fatal_error("$badusers $txt{'747'}");
}

$yySetLocation = qq~$cgi;action=im~;
</search for>

<add after>
if (defined($pm_IM_send) && $pm_IM_send ne ''){
    $yySetLocation = $pm_IM_send;
}
</add after>
